﻿using NModbus;
using NModbus.Extensions.Enron;
using NModbus.Serial;
using System;
using System.IO.Ports;

namespace ModbusLearn
{
    internal class Program
    {
        static void Main(string[] args)
        {
            using (SerialPort port = new SerialPort("COM5"))
            {
                // configure serial port
                port.BaudRate = 9600;
                port.DataBits = 8;
                port.Parity = Parity.None;
                port.StopBits = StopBits.One;
                port.Open();

                // Wrap the serial port
                var adapter = new SerialPortAdapter(port);

                // Create the factory
                var factory = new ModbusFactory();

                // Create Modbus Master
                IModbusMaster master = factory.CreateRtuMaster(adapter);

                byte slaveId = 1;
                ushort startAddress = 100;
                ushort[] registers = new ushort[] { 1, 2, 3 };

                // write three registers
                master.WriteMultipleRegisters(slaveId, startAddress, registers);
            }
        }
    }
}
